unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, Buttons, XPMan;

type
  TForm1 = class(TForm)
    attrChange: TCheckListBox;
    OpenFile: TOpenDialog;
    label1: TLabel;
    edit1: TEdit;
    btn1: TBitBtn;
    xpmnfst1: TXPManifest;
    procedure edit1DblClick(Sender: TObject);
    procedure edit1Change(Sender: TObject);
    procedure attrChangeClickCheck(Sender: TObject);
    procedure attrChangeClick(Sender: TObject);
    procedure refresh_btnClick(Sender: TObject);
    procedure btn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetAttr;
    function CheckFN(var fcount:word):boolean;
    function GetFirstFN(var files:string):string;
    procedure UnknownAttr;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure OpenF;
var i:word;
    s:string;
begin
  if Form1.OpenFile.Execute then
    begin
      s:='';
      for i:=0 to Form1.OpenFile.Files.Count-1 do
        begin
          if s<>'' then
            s:=s+'|'+Form1.OpenFile.Files[i]
          else
            s:=Form1.OpenFile.Files[i];
        end;
      Form1.edit1.Text:=s;
    end;
  Form1.CheckFN(i);
end;

procedure TForm1.edit1DblClick(Sender: TObject);
begin
  OpenF;
end;

function TForm1.GetFirstFN(var files:string):string;
var i:integer;
begin
  i:=pos('|',files);
  if i>0 then
    begin
      result:=copy(files,1,i-1);
      delete(files,1,i);
    end
  else
    result:=files;
end;

function TForm1.CheckFN(var fcount:word):boolean;
var s,fn:string;
    i:integer;
    fl:boolean;
begin
  s:=edit1.Text;
  if edit1.Text<>'' then
    begin
      fl:=true;
      fcount:=1;
    end
  else
    begin
      fl:=false;
      fcount:=0;
    end;
  i:=pos('|',s);
  while (i>0)and fl do
    begin
      inc(fcount);
      fn:=copy(s,1,i-1);
      delete(s,1,i);
      if not (fileexists(fn) or DirectoryExists(fn)) then
        fl:=false;
      i:=pos('|',s);
    end;
  if fl and (fcount=1) then
    if not (fileexists(s) or DirectoryExists(s)) then
      fl:=false;
  if fl and(fcount>0) then
    begin
      edit1.ParentFont:=true;
      attrChange.Enabled:=true;
      result:=true;
      label1.Caption:=inttostr(fcount)+' ()';
    end
  else
    begin
      edit1.Font.Color:=$0000FF; // = Graphics.clRed
      attrChange.Enabled:=false;
      label1.Caption:='      ';
      result:=false;
    end;
end;

procedure TForm1.UnknownAttr;
var i:integer;
begin
  for i:=0 to attrChange.Count-1 do
    attrChange.Checked[i]:=false;
end;

procedure TForm1.GetAttr;
var attr:cardinal;
    fcount:word;
    i:word;
    s,fn:string;

  procedure Switch_AttrCLB(idx:integer; value, fl_first:boolean);
  begin
    with attrChange do
      begin
        if fl_first then
          begin
            if value then
              state[idx]:=cbChecked
            else
              state[idx]:=cbUnchecked;
          end
        else
          begin
            if value and (state[idx]=cbChecked) then
              state[idx]:=cbChecked
            else
              if (value and (state[idx]=cbUnchecked))or((not value)and(state[idx]=cbChecked)) then
                state[idx]:=cbGrayed
              else
                if value and (state[idx]=cbGrayed) then
                  state[idx]:=cbGrayed
                else
                  if (not value)and(state[idx]=cbUnchecked) then
                    state[idx]:=cbUnchecked;
          end;
      end;
  end;
begin
  if not CheckFN(fcount) then
    begin
      UnknownAttr;
      exit;
    end;
  s:=edit1.Text;
  attrChange.AllowGrayed:=true;
  for i:=1 to fcount do
    begin
      fn:=GetFirstFN(s);
      attr:=windows.GetFileAttributes(PChar(fn));
      if (attr and faSysFile)<>0 then
        Switch_AttrCLB(0,true,(i=1))
      else
        Switch_AttrCLB(0,false,(i=1));
      if (attr and faHidden)<>0 then
        Switch_AttrCLB(1,true,(i=1))
      else
        Switch_AttrCLB(1,false,(i=1));
      if (attr and faReadOnly)<>0 then
        Switch_AttrCLB(2,true,(i=1))
      else
        Switch_AttrCLB(2,false,(i=1));
      if (attr and faArchive)<>0 then
        Switch_AttrCLB(3,true,(i=1))
      else
        Switch_AttrCLB(3,false,(i=1));
    end;
  attrChange.AllowGrayed:=false;
end;

procedure TForm1.edit1Change(Sender: TObject);
var fcount:word;
begin
  if not CheckFN(fcount) then
    exit;
  GetAttr;
end;

procedure TForm1.attrChangeClickCheck(Sender: TObject);
var attr,a:cardinal;
    i,fcount:word;
    s,fn:string;
begin
  if not CheckFN(fcount) then
    exit;
  s:=edit1.Text;
  case attrChange.ItemIndex of
    0:a:=faSysFile;
    1:a:=faHidden;
    2:a:=faReadOnly;
    3:a:=faArchive
    else
      a:=$FFFFFFFF; //   a   
  end;
  {faReadOnly	:    
faHidden :  
faSysFile :  
faVolumeID	:   
faDirectory : 
faArchive :  
faSymLink :   ()}
  for i:=1 to fcount do
    begin
      fn:=GetFirstFN(s);
      attr:=windows.GetFileAttributes(PChar(fn));
      if attrChange.State[attrChange.ItemIndex] in [cbChecked, cbGrayed] then
        attr:=attr or a
      else
        attr:=(attr and ($FFFFFFFF - a));
      windows.SetFileAttributes(PChar(fn),attr); //fn - file name
      {windows.SetFileAttributesA(PChar(fn),attr);
      windows.SetFileAttributesW(PWideChar(fn),attr);}
    end;
  //showmessage(inttostr(attr));
  GetAttr;
end;

procedure TForm1.attrChangeClick(Sender: TObject);
begin
  //attr_clb.Checked[attr_clb.ItemIndex]:=not attr_clb.Checked[attr_clb.ItemIndex];
  attrChange.OnClickCheck(self);
end;

procedure TForm1.refresh_btnClick(Sender: TObject);
begin
  GetAttr;
end;

procedure TForm1.btn1Click(Sender: TObject);
begin
  OpenF;
end;

end.
